<?php
//  Install script for bookmodule                                               //
//  $Revision: 1.7.2.4 $                                                            //
//  --------------------------------------------------------------------------  //
//  XooNIps Xoops modules for Neuroinformatics Platforms                        //
//  Copyright (C) 2005 RIKEN, Japan. All rights reserved.                       //
//  http://sourceforge.jp/projects/xoonips/                                     //
//  --------------------------------------------------------------------------  //
//  This program is free software; you can redistribute it and/or               //
//  modify it under the terms of the GNU General Public License                 //
//  as published by the Free Software Foundation; either version 2              //
//  of the License, or (at your option) any later version.                      //
//                                                                              //
//  This program is distributed in the hope that it will be useful,             //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with this program; if not, write to the Free Software                 //
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. //
//  --------------------------------------------------------------------------  //
function xoops_module_install_xnpbook( $xoopsMod ) {
	global $xoopsDB;
	
	// register itemtype
	$table = $xoopsDB->prefix('xoonips_item_type');
	$mid = $xoopsMod->getVar('mid');
	$sql = "INSERT INTO $table ( name, display_name, mid, viewphp ) VALUES ( 'xnpbook', 'Book', $mid, 'xnpbook/include/view.php' )";
	if ( $xoopsDB->query($sql) == FALSE ){
		// cannot register itemtype
		return false;
	}
	
	// register filetype
	$table = $xoopsDB->prefix('xoonips_file_type');
	$mid = $xoopsMod->getVar('mid');
	$sql = "INSERT INTO $table ( name, display_name, mid ) VALUES ( 'book_pdf', 'PDF File(Book)', $mid )";
	if ( $xoopsDB->query($sql) == FALSE ){
		// cannot register itemtype
		return false;
	}

	// Delete 'Module Access Rights' from all groups
	// This allows to remove redundant module name in Main Menu
	$member_handler =& xoops_gethandler('member');
	$gperm_handler =& xoops_gethandler('groupperm');
	$groups =& $member_handler->getGroupList();
	foreach ($groups as $groupid2 => $groupname) {
		if ($gperm_handler->checkRight('module_read', $mid, $groupid2)) {
			$criteria = new CriteriaCompo();
			$criteria->add( new Criteria( 'gperm_groupid', $groupid2 ) );
			$criteria->add( new Criteria( 'gperm_itemid', $mid ) );
			$criteria->add( new Criteria( 'gperm_name', 'module_read' ) );
			
			$objects = $gperm_handler->getObjects($criteria);
			if ( count( $objects ) == 1 ){
				$gperm_handler->delete( $objects[0] );
			}
		}
	}
	
	//$item_type_id = $xoopsDB->getInsertId();
	return true;
} 

function xoops_module_uninstall_xnpbook( $xoopsMod ) {
	global $xoopsDB;
	
	$item_type_id = -1;
	$table = $xoopsDB->prefix('xoonips_item_type');
	$mid = $xoopsMod->getVar('mid');
	$sql = "SELECT item_type_id FROM $table where mid = $mid";
	$result = $xoopsDB->query($sql);
	if ( $result ){
		list($item_type_id) = $xoopsDB->fetchRow($result);
	}else{
		echo mysql_error();
		echo $sql;
		return false;
	}
	
	// set Deleted state to repository item_status table.
	$table = $xoopsDB->prefix('xoonips_item_basic');
	$sql = "SELECT item_id from ${table} WHERE item_type_id = $item_type_id";
	$result = $xoopsDB->query($sql);
	if ( !$result ){
		echo mysql_error();
		echo $sql;
		return false;
	}
	$ids = array( );
	while( list( $item_id ) = $xoopsDB->fetchRow($result) ){
		$ids[] = $item_id;
	}
	if( count( $ids ) > 0 ){
		$table = $xoopsDB->prefix('xoonips_item_status');
		$sql = "UPDATE ${table} SET deleted_timestamp=UNIX_TIMESTAMP(NOW()), is_deleted=1 WHERE item_id in ( ".implode( ",", $ids ).")";
		if ( $xoopsDB->query($sql) == FALSE ){
			echo mysql_error();
			echo $sql;
			return false;
		}
	}
	
	// remove basic information
	$table = $xoopsDB->prefix('xoonips_item_basic');
	$sql = "DELETE FROM $table where item_type_id = $item_type_id";
	if ( $xoopsDB->query($sql) == FALSE ){
		echo mysql_error();
		echo $sql;
		return false;
	}

	// unregister itemtype
	$table = $xoopsDB->prefix('xoonips_item_type');
	$mid = $xoopsMod->getVar('mid');
	$sql = "DELETE FROM $table where mid = $mid";
	if ( $xoopsDB->query($sql) == FALSE ){
		echo mysql_error();
		echo $sql;
		return false;
	}
	$table = $xoopsDB->prefix('xoonips_file_type');
	$sql = "DELETE FROM $table where mid = $mid";
	if ( $xoopsDB->query($sql) == FALSE ){
		echo mysql_error();
		echo $sql;
		return false;
	}
	return true;
}

function xoops_module_update_xnpbook ( $xoopsMod, $oldversion) {

	global $xoopsDB;
	switch ($oldversion) { //remember that version is multiplied with 100 to get an integer
	case 100: //perform actions to upgrade from version 1.00
//		global $xoopsDB;
		$sql = sprintf("ALTER TABLE %s ADD attachment_dl_limit int(1) unsigned default 0", $xoopsDB->prefix("xnpbook_item_detail"));
		$result = $xoopsDB->query($sql);
		if( !$result ){
			echo "ERROR: " . $xoopsDB->error();
			return false;
		}
		return true;
	case 101:
	case 102:
// correction different encoding data in DB caused by no-converting ISBN information from 'UTF-8' to specified encoding at registration.
		if (_CHARSET != 'UTF-8') {
			include_once XOOPS_ROOT_PATH.'/modules/xoonips/include/encode.php';
			$table1 = $xoopsDB->prefix("xnpbook_item_detail");
			$table2 = $xoopsDB->prefix('xoonips_item_basic');
			$items = array( );
			$sql1 = "SELECT book_id, author, publisher FROM $table1";
			$result1 = $xoopsDB->query($sql1);
			if( !$result1 ){
				echo "ERROR: " . $xoopsDB->error();
				return false;
			}
			$i = 0;
			while ( list($book_id, $author, $publisher) = $xoopsDB->fetchRow($result1) ) {
				if (_CHARSET == 'EUC-JP') {
					$author = encodeServer2Client($author);
					$publisher = encodeServer2Client($publisher);
				}
				$author = encodeClient2Server($author);
				$author = addslashes($author);
				$publisher = encodeClient2Server($publisher);
				$publisher = addslashes($publisher);
				$sql2 = "SELECT title FROM $table2 where item_id=$book_id";
				$result2 = $xoopsDB->query($sql2);
				if( !$result2 ){
					echo "ERROR: " . $xoopsDB->error();
					return false;
				}
				list($title) = $xoopsDB->fetchRow($result2);
				if (_CHARSET == 'EUC-JP') {
					$title = encodeServer2Client($title);
				}
				$title = encodeClient2Server($title);
				$title = addslashes($title);
				$sql3 = "UPDATE $table2 SET title='$title' where item_id=$book_id";
				$result3 = $xoopsDB->query($sql3);
				if( !$result3 ){
					echo "ERROR: " . $xoopsDB->error();
					return false;
				}
				$sql4 = "UPDATE $table1 SET author='$author', publisher='$publisher' where book_id=$book_id";
				$result4 = $xoopsDB->query($sql4);
				if( !$result4 ){
					echo "ERROR: " . $xoopsDB->error();
					return false;
				}
			}
		}
	case 110: // 110->111: author varchar -> text
		$result = $xoopsDB->query( "ALTER TABLE ".$xoopsDB->prefix('xnpbook_item_detail')." CHANGE COLUMN author author TEXT NOT NULL" );
		if( !$result ){
			echo "ERROR: " . $xoopsDB->error();
			return false;
		}
		
	default:
		return true;
	}
	return true;
}
?>
