<?php
//  XNP Module definition                                                       //
//  $Revision: 1.18.2.4 $                                                                  //
//  --------------------------------------------------------------------------  //
//  XooNIps Xoops modules for Neuroinformatics Platforms                        //
//  Copyright (C) 2005 RIKEN, Japan. All rights reserved.                       //
//  http://sourceforge.jp/projects/xoonips/                                     //
//  --------------------------------------------------------------------------  //
//  This program is free software; you can redistribute it and/or               //
//  modify it under the terms of the GNU General Public License                 //
//  as published by the Free Software Foundation; either version 2              //
//  of the License, or (at your option) any later version.                      //
//                                                                              //
//  This program is distributed in the hope that it will be useful,             //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of              //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               //
//  GNU General Public License for more details.                                //
//                                                                              //
//  You should have received a copy of the GNU General Public License           //
//  along with this program; if not, write to the Free Software                 //
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. //
//  --------------------------------------------------------------------------  //

// 1.00 -> 1.01 add 'lang' field to xoonips_item_basic
// 1.01 -> 1.02 support OAI-PMH(new tables xoonips_item_status, xoonips_oaipmh_repositories, xoonips_oaipmh_metadata and xoonips_oaipmh_resumption_token)
// 1.02 -> 1.03 support Related to(new table xoonips_related_to)
// 1.03 -> 1.10 Public presentation of the current version
// 1.11 -> 1.11 removing zombie items which lost the link to basic information

$modversion['name'] = _MI_XOONIPS_NAME;
$modversion['version'] = 2.00;
$modversion['description'] = _MI_XOONIPS_DESC;
$modversion['credits'] =
"RIKEN, Japan.<br/>"
."<a target=\"blank\" href=\"http://www.riken.jp/\">http://www.riken.jp/</a>";
$modversion['author'] = 
"Neuroinformatics Laboratry, RIKEN BSI.<br/>"
."<a target=\"blank\" href=\"http://www.ni.brain.riken.jp/\">http://www.ni.brain.riken.jp/</a><br/><br/>"
."The XooNIps Project. <br/>"
."<a target=\"blank\" href=\"http://sourceforge.jp/projects/xoonips/\">http://sourceforge.jp/projects/xoonips/</a>";
$modversion['help'] = "help.html";
$modversion['license'] = "GPL see LICENSE";
$modversion['official'] = 0;
$modversion['image'] = "images/xoonips_slogo.png";
$modversion['dirname'] = "xoonips";

// Sql file (must contain sql generated by phpMyAdmin or phpPgAdmin)
// All tables should not have any prefix!
$modversion['sqlfile']['mysql'] = "sql/mysql.sql";
$modversion['tables'][ 0] = "xoonips_item_basic";
$modversion['tables'][ 1] = "xoonips_index_item_link";
$modversion['tables'][ 2] = "xoonips_index";
$modversion['tables'][ 3] = "xoonips_binder_item_link";
$modversion['tables'][ 4] = "xoonips_changelog";
$modversion['tables'][ 5] = "xoonips_item_type";
$modversion['tables'][ 6] = "xoonips_file";
$modversion['tables'][ 7] = "xoonips_file_type";
$modversion['tables'][ 8] = "xoonips_users";
$modversion['tables'][ 9] = "xoonips_config";
$modversion['tables'][10] = "xoonips_groups";
$modversion['tables'][11] = "xoonips_groups_users_link";
$modversion['tables'][12] = "xoonips_session";
$modversion['tables'][13] = "xoonips_event_log";
$modversion['tables'][14] = "xoonips_item_status";
$modversion['tables'][15] = "xoonips_oaipmh_resumption_token";
$modversion['tables'][16] = "xoonips_oaipmh_repositories";
$modversion['tables'][17] = "xoonips_oaipmh_metadata";
$modversion['tables'][18] = "xoonips_related_to";


//Admin things
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "admin/index.php";
$modversion['adminmenu'] = "admin/menu.php";

// Menu
$modversion['hasMain'] = 1;
/*
$modversion['sub'][ 1]['name'] = _MI_XOONIPS_ITEM_SMNAME1;
$modversion['sub'][ 1]['url'] = "register.php";
$modversion['sub'][ 2]['name'] = _MI_XOONIPS_ITEM_SMNAME2;
$modversion['sub'][ 2]['url'] = "certify.php";
$modversion['sub'][ 3]['name'] = _MI_XOONIPS_ITEM_SMNAME3;
$modversion['sub'][ 3]['url'] = "advanced_search.php";
$modversion['sub'][ 4]['name'] = _MI_XOONIPS_MODERATOR_SMNAME1;
$modversion['sub'][ 4]['url'] = "editgroups.php";
$modversion['sub'][ 5]['name'] = _MI_XOONIPS_MODERATOR_SMNAME2;
$modversion['sub'][ 5]['url'] = "certifyuser.php";
$modversion['sub'][ 6]['name'] = _MI_XOONIPS_INDEX_SMNAME1;
$modversion['sub'][ 6]['url'] = "editindex.php";
$modversion['sub'][ 7]['name'] = _MI_XOONIPS_INDEX_SMNAME2;
$modversion['sub'][ 7]['url'] = "editindex.php?xid=1"; // 1 = ROOT/   // Start is ROOT, because two or more group might exist.
$modversion['sub'][ 8]['name'] = _MI_XOONIPS_INDEX_SMNAME3;
$modversion['sub'][ 8]['url'] = "editindex.php?xid=3"; // 3 = ROOT/PUBLIC/
$modversion['sub'][ 9]['name'] = _MI_XOONIPS_ACCOUNT_SMNAME1;
$modversion['sub'][ 9]['url'] = "userinfo.php";
$modversion['sub'][10]['name'] = _MI_XOONIPS_ACCOUNT_SMNAME2;
$modversion['sub'][10]['url'] = "edituser.php";
$modversion['sub'][11]['name'] = _MI_XOONIPS_ACCOUNT_SMNAME4;
$modversion['sub'][11]['url'] = "groupadmin.php";
*/





// Templates
$modversion['templates'][ 1]['file'] = 'xoonips_itemlist.html';
$modversion['templates'][ 1]['description'] = 'item listing';
$modversion['templates'][ 2]['file'] = 'xoonips_register.html';
$modversion['templates'][ 2]['description'] = 'register item';
$modversion['templates'][ 3]['file'] = 'xoonips_confirm_register.html';
$modversion['templates'][ 3]['description'] = 'confirmation before register';
$modversion['templates'][ 4]['file'] = 'xoonips_certify.html';
$modversion['templates'][ 4]['description'] = 'certify items';
$modversion['templates'][ 5]['file'] = 'xoonips_edit.html';
$modversion['templates'][ 5]['description'] = 'edit item';
$modversion['templates'][ 6]['file'] = 'xoonips_confirm_edit.html';
$modversion['templates'][ 6]['description'] = 'confirm edit item';
$modversion['templates'][ 7]['file'] = 'xoonips_detail.html';
$modversion['templates'][ 7]['description'] = 'detail item';
$modversion['templates'][ 8]['file'] = 'xoonips_itemselect.html';
$modversion['templates'][ 8]['description'] = 'select item form';
$modversion['templates'][ 9]['file'] = 'xoonips_publication_date.html';
$modversion['templates'][ 9]['description'] = 'publication_date form';
$modversion['templates'][10]['file'] = 'xoonips_publication_year.html';
$modversion['templates'][10]['description'] = 'publication_year form';
$modversion['templates'][11]['file'] = 'xoonips_publication_month.html';
$modversion['templates'][11]['description'] = 'publication_month form';
$modversion['templates'][12]['file'] = 'xoonips_publication_mday.html';
$modversion['templates'][12]['description'] = 'publication_mday form';
$modversion['templates'][13]['file'] = 'xoonips_search_date.html';
$modversion['templates'][13]['description'] = 'search_date form';
$modversion['templates'][14]['file'] = 'xoonips_search_year.html';
$modversion['templates'][14]['description'] = 'search_year form';
$modversion['templates'][15]['file'] = 'xoonips_search_month.html';
$modversion['templates'][15]['description'] = 'search_month form';
$modversion['templates'][16]['file'] = 'xoonips_search_mday.html';
$modversion['templates'][16]['description'] = 'search_mday form';
$modversion['templates'][17]['file'] = 'xoonips_advanced_search.html';
$modversion['templates'][17]['description'] = 'advanced search form';
$modversion['templates'][18]['file'] = 'xoonips_main.html';
$modversion['templates'][18]['description'] = 'xoonips main page';
$modversion['templates'][19]['file'] = 'xoonips_editgroups.html';
$modversion['templates'][19]['description'] = 'edit groups';
$modversion['templates'][20]['file'] = 'xoonips_certifyuser.html';
$modversion['templates'][20]['description'] = 'certify user';
$modversion['templates'][21]['file'] = 'xoonips_editindex.html';
$modversion['templates'][21]['description'] = 'edit index page';
$modversion['templates'][22]['file'] = 'xoonips_list_block.html';
$modversion['templates'][22]['description'] = 'list block';
$modversion['templates'][23]['file'] = 'xoonips_register_block.html';
$modversion['templates'][23]['description'] = 'register block';
$modversion['templates'][24]['file'] = 'xoonips_detail_block.html';
$modversion['templates'][24]['description'] = 'detail block';
$modversion['templates'][25]['file'] = 'xoonips_confirm_block.html';
$modversion['templates'][25]['description'] = 'confirm block';
$modversion['templates'][26]['file'] = 'xoonips_groupadmin.html';
$modversion['templates'][26]['description'] = 'edit group';
$modversion['templates'][27]['file'] = 'xoonips_userform.html';
$modversion['templates'][27]['description'] = 'lost password';
$modversion['templates'][28]['file'] = 'xoonips_userinfo.html';
$modversion['templates'][28]['description'] = 'account info';
$modversion['templates'][29]['file'] = 'xoonips_index.html';
$modversion['templates'][29]['description'] = 'xoonips module top page';
$modversion['templates'][30]['file'] = 'xoonips_export_license.html';
$modversion['templates'][30]['description'] = 'xoonips license agreement ( export )';
$modversion['templates'][31]['file'] = 'xoonips_event_log.html';
$modversion['templates'][31]['description'] = 'xoonips event log page';
$modversion['templates'][32]['file'] = 'xoonips_import_item.html';
$modversion['templates'][32]['description'] = 'xoonips item select page for import';
$modversion['templates'][33]['file'] = 'xoonips_group_list.html';
$modversion['templates'][33]['description'] = 'xoonips group list';
$modversion['templates'][34]['file'] = 'xoonips_detail_print.html';
$modversion['templates'][34]['description'] = 'xoonips detail page ( printer friendly )';
$modversion['templates'][35]['file'] = 'xoonips_itemselect_print.html';
$modversion['templates'][35]['description'] = 'xoonips search page ( printer friendly )';
$modversion['templates'][36]['file'] = 'xoonips_top_itemtype_block.html';
$modversion['templates'][36]['description'] = 'xoonips top page itemtype block';
$modversion['templates'][37]['file'] = 'xoonips_lang.html';
$modversion['templates'][37]['description'] = 'xoonips select item language';
$modversion['templates'][38]['file'] = 'xoonips_metadata_search.html';
$modversion['templates'][38]['description'] = 'xoonips metadata search page';
$modversion['templates'][39]['file'] = 'xoonips_detail_related_to.html';
$modversion['templates'][39]['description'] = 'related to form for detail';
$modversion['templates'][40]['file'] = 'xoonips_edit_related_to.html';
$modversion['templates'][40]['description'] = 'related to form for edit';
$modversion['templates'][41]['file'] = 'xoonips_confirm_related_to.html';
$modversion['templates'][41]['description'] = 'related to form for confirm';
$modversion['templates'][42]['file'] = 'xoonips_register_related_to.html';
$modversion['templates'][42]['description'] = 'related to form for register';
$modversion['templates'][43]['file'] = 'xoonips_related_to_itemselect.html';
$modversion['templates'][43]['description'] = 'itemselect for related to sub window';






// Blocks
$modversion['blocks'][1]['file'] = "xoonips_blocks.php";
$modversion['blocks'][1]['name'] = _MI_XOONIPS_ITEM_BNAME1;
$modversion['blocks'][1]['description'] = "Shows xoonips quick search block";
$modversion['blocks'][1]['show_func'] = "b_xoonips_quick_search_show";
$modversion['blocks'][1]['edit_func'] = "";
$modversion['blocks'][1]['template'] = 'xoonips_block_quick_search.html';
$modversion['blocks'][1]['options'] = "";

$modversion['blocks'][2]['file'] = "xoonips_blocks.php";
$modversion['blocks'][2]['name'] = _MI_XOONIPS_ACCOUNT_BNAME4;
$modversion['blocks'][2]['description'] = "Shows moderator menu";
$modversion['blocks'][2]['show_func'] = "b_xoonips_moderator_show";
$modversion['blocks'][2]['template'] = 'xoonips_block_moderator.html';

$modversion['blocks'][3]['file'] = "xoonips_blocks.php";
$modversion['blocks'][3]['name'] = _MI_XOONIPS_INDEX_BNAME1;
$modversion['blocks'][3]['description'] = "browse block";
$modversion['blocks'][3]['show_func'] = "b_xoonips_tree_show";
$modversion['blocks'][3]['edit_func'] = "";
$modversion['blocks'][3]['template'] = 'xoonips_block_tree.html';
$modversion['blocks'][3]['options'] = "";

$modversion['blocks'][4]['file'] = "xoonips_blocks.php";
$modversion['blocks'][4]['name'] = _MI_XOONIPS_ACCOUNT_BNAME1;
$modversion['blocks'][4]['description'] = "Shows xoonips login block";
$modversion['blocks'][4]['show_func'] = "b_xoonips_login_show";
$modversion['blocks'][4]['edit_func'] = "";
$modversion['blocks'][4]['template'] = 'xoonips_block_login.html';
$modversion['blocks'][4]['options'] = "";

$modversion['blocks'][5]['file'] = "xoonips_blocks.php";
$modversion['blocks'][5]['name'] = _MI_XOONIPS_ACCOUNT_BNAME2;
$modversion['blocks'][5]['description'] = "Shows user menu";
$modversion['blocks'][5]['show_func'] = "b_xoonips_user_show";
$modversion['blocks'][5]['template'] = 'xoonips_block_user.html';

$modversion['blocks'][6]['file'] = "xoonips_blocks.php";
$modversion['blocks'][6]['name'] = _MI_XOONIPS_ACCOUNT_BNAME3;
$modversion['blocks'][6]['description'] = "Shows group menu";
$modversion['blocks'][6]['show_func'] = "b_xoonips_group_show";
$modversion['blocks'][6]['template'] = 'xoonips_block_group.html';

// config

$modversion['config'][1]['name'] = 'dsn';
$modversion['config'][1]['title'] = '_MI_XOONIPS_CONFIG_DSN';
$modversion['config'][1]['description'] = '_MI_XOONIPS_CONFIG_DSN_DESC';
$modversion['config'][1]['formtype'] = 'textbox';
$modversion['config'][1]['valuetype'] = 'text';
$modversion['config'][1]['default'] = 'localhost';


$modversion['onInstall'] = 'install_funcs.php'; 
$modversion['onUpdate'] = 'install_funcs.php'; 

?>
